#!/usr/bin/env python

'''
sjRpc client example.
'''

from __future__ import absolute_import

import sys
import threading
import time

from sjrpc.core import RpcConnection
from sjrpc.core.protocols import TunnelProtocol

bytes_received = 0

def perf(socket):
    global bytes_received
    while True:
        read = socket.recv(1024 * 1024)
        bytes_received += len(read)

# Get arguments from the command line:
if len(sys.argv) < 3:
    print 'Usage: %s <listening address> <listening port>' % sys.argv[0]
    sys.exit(2)
address = sys.argv[1]
port = int(sys.argv[2])

# Create the rpc connection:
conn = RpcConnection.from_addr_ssl(address, port)

print 'connected.'

# Run the connection mainloop in another thread:
threading.Thread(target=conn.run).start()
time.sleep(0.1)

label = conn.call('launch_perf')
tun = conn.register_protocol(label, TunnelProtocol)
t = threading.Thread(target=perf, args=(tun._socket,))
t.daemon = True
t.start()

last = 0
while True:
    bytes_received, b = 0, bytes_received
    bw = ((b / 1024.0 / 1024) / 2)
    print '%.2f MB/s\t\t\t%.2f Mb/s\t\t\tDelta: %+0.2f' % (bw, bw * 8, (bw - last) * 8)
    last = bw
    time.sleep(2)

conn.shutdown()

