# This file is part of CloudControl.
#
# CloudControl is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# CloudControl is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with CloudControl.  If not, see <http://www.gnu.org/licenses/>.


""" This module implements a Remote Procedure Call system using socket objects
    as transport. The main feature of this RPC is to be bidirectionnal: both
    client and server can serve remote procedure for its peer.

Features:

 * Multiplexed: you can run tunnels or many RPC through the same socket.
 * Gevent: sjRpc is compatible with gevent and use it for server feature.
 * Bidirectionnal: each peer can call remote function on other.

The library is separated into three parts:

 * **core** package contains all common classes.
 * **server** package contains all the server side related stuff.
 * **utils** package contains some helpers used in previous libraries.
"""

__version__ = '19'
